/*
      SoundMan v0.1 - Realtime frequency analyzer
      Copyright (C) 1999 Gabor Kerenyi (wom@fireball.kalmar.hu)
*/

#include <qwidget.h>
#include "fdata.h"
#include "main.h"
#include <qscrollbar.h>
#include <qpainter.h>
#include <fcntl.h>
#include <math.h>
#include <qfont.h>

extern cnf mconf;
QPainter p;

FData::FData(QWidget *parent, const char *name): QWidget(parent,name)
{
setBackgroundColor(QColor(0,0,0));
setBackgroundMode(FixedColor);
setPalette(QPalette(QColor(0,0,0)));
}

int exp10(int i)
{
   int j,k;
   k=1;
   for (j=0;j<i;j++)
   {
	k*=10;
   }
   return k;
}

void FData::mkc_v(int maxx,int maxy)
{
   int i,j;
   int y;
   char s[10];
   float magy;
   p.setPen(QColor(mconf.col.ampl_y.r,mconf.col.ampl_y.g,mconf.col.ampl_y.b));
   p.drawLine(30,maxy,30,0);
   p.setPen(QColor(mconf.col.ampl_ylines.r,mconf.col.ampl_ylines.g,mconf.col.ampl_ylines.b));
   if (mconf.spect.displayy==0)
   {
	magy=(float)(maxy-40)/100;
        for (i=0;i<=100;i+=10)
	{
		y=(int)((float)i*magy);
	     if ((i==50)||(i==100))
		{
			p.drawLine(20,maxy-30-y,30,maxy-30-y);
		}
	     else{
			if (i>0) p.drawLine(25,maxy-30-y,30,maxy-30-y);
		}
		sprintf(s,"%d",i);
		if (i!=0) 
		{
			p.setPen(QColor(mconf.col.ampl_ytext.r,mconf.col.ampl_ytext.g,mconf.col.ampl_ytext.b));
			p.drawText(2,maxy-25-y,s);
   			p.setPen(QColor(mconf.col.ampl_ylines.r,mconf.col.ampl_ylines.g,mconf.col.ampl_ylines.b));
			if (mconf.spect.xyarrangers) p.drawLine(30,maxy-30-y,maxx,maxy-30-y);
		}
	}
   }
   else{
	magy=(float)(maxy-40)/log10(100);
        j=1;
	for (i=1;i<=100;i+=j)
	{
	if (i>=10) j=10;
		y=(int)(log10(i+1)*magy);
	if ((i==10)||(i==50)||(i==100)){
		
		p.drawLine(20,maxy-30-y,30,maxy-30-y);
		sprintf(s,"%d",i);
		p.setPen(QColor(mconf.col.ampl_ytext.r,mconf.col.ampl_ytext.g,mconf.col.ampl_ytext.b));
		p.drawText(2,maxy-25-y,s);
   		p.setPen(QColor(mconf.col.ampl_ylines.r,mconf.col.ampl_ylines.g,mconf.col.ampl_ylines.b));
			}
	else
		p.drawLine(25,maxy-30-y,30,maxy-30-y);
	if (mconf.spect.xyarrangers) p.drawLine(30,maxy-30-y,maxx,maxy-30-y);
	}
   }
   p.setPen(QColor(mconf.col.ampl_ytext.r,mconf.col.ampl_ytext.g,mconf.col.ampl_ytext.b));
   p.drawText(2,maxy-10,"(%)");
}

void FData::mkc(int maxx,int maxy)
{
  int i,lg,x,step1,step2;
  float magx,magx1;
  char s[10];
  p.setPen(QColor(mconf.col.ampl_x.r,mconf.col.ampl_x.g,mconf.col.ampl_x.b));
  p.drawLine(0,maxy-30,maxx,maxy-30);
  p.setPen(QColor(mconf.col.ampl_xlines.r,mconf.col.ampl_xlines.g,mconf.col.ampl_xlines.b));
 
  step1=0;
  step2=0;

  if  (mconf.spect.displayx==1)
  {
  magx=log10(mconf.spect.pn)/(float)(maxx-30);
  magx1=log10(mconf.wave.freq/2)/(float)(maxx-30);
	for (lg=0;lg<=log10(mconf.wave.freq/2)+1;lg++)
	{
	   for  (i=exp10(lg);((i<=exp10(lg+1))&&(i<mconf.wave.freq/2));i+=exp10(lg)){
			x=(int)(log10(i)/magx1);
			if ((i==exp10(lg)) && (i>1)){
				p.drawLine(30+x,maxy-30,30+x,maxy-20);
		   		sprintf(s,"%dHz",i);
				p.setPen(QColor(mconf.col.ampl_xtext.r,mconf.col.ampl_xtext.g,mconf.col.ampl_xtext.b));
		  		p.drawText(30+x-strlen(s)*3,maxy-8,s); 
				p.setPen(QColor(mconf.col.ampl_xlines.r,mconf.col.ampl_xlines.g,mconf.col.ampl_xlines.b));
			}
			else p.drawLine(30+x,maxy-30,30+x,maxy-25);			
			if (mconf.spect.xyarrangers) p.drawLine(30+x,maxy-30,30+x,5);
		}
	}
  }
  else
  {
     if (mconf.wave.freq==44100){step1=500;step2=2500;}
     if (mconf.wave.freq==22050){step1=200;step2=1000;}
     if (mconf.wave.freq==11025){step1=100;step2=1000;}
     magx1=(float)(mconf.wave.freq/2)/(float)(maxx-30);
     for (i=1;i<mconf.wave.freq/2;i++)
     {
	x=(int)((float)i/magx1);
	if (i%step1==0)
	{
		if (i%step2==0)
		{
		   p.drawLine(30+x,maxy-30,30+x,maxy-20);
		   sprintf(s,"%.1fkHz",(double)i/1000.0);
		   p.setPen(QColor(mconf.col.ampl_xtext.r,mconf.col.ampl_xtext.g,mconf.col.ampl_xtext.b));
		   p.drawText(30+x-strlen(s)*3,maxy-8,s); 
		   p.setPen(QColor(mconf.col.ampl_xlines.r,mconf.col.ampl_xlines.g,mconf.col.ampl_xlines.b));
		}
		else
		p.drawLine(30+x,maxy-30,30+x,maxy-25);
		if (mconf.spect.xyarrangers) p.drawLine(30+x,maxy-30,30+x,5);
	}
     }     
  }
}

void FData::paintEvent(QPaintEvent *)
{
   int maxx=width();
   int maxy=height();
   int basey;
   int ee;
   int re;
   int ex;
   int x;
   long i;
   long k;
   float ymag,xmag;

   basey=maxy-30;
   if (mconf.spect.displayy)
      ymag=(float)(basey-10)/2;
   else
      ymag=(double)(basey-10)/mconf.spect.maxpower;
   p.begin(this);
   p.setPen(QColor(0,0,0));
   p.setFont(QFont("times"));
   mkc(maxx,maxy);
   mkc_v(maxx,maxy);
   if (mconf.spect.displayx==1)
      xmag=(float)(log10(mconf.wave.freq/2))/(float)(maxx-30);
   else 
      xmag=(double)(((mconf.spect.pn)))/(float)(maxx-30);
   if (mconf.spect.displayx==1) 
      ex=(int)(log10((float)(mconf.wave.freq/2)/(float)(mconf.spect.pn)*1.0)/xmag+30);
   else 
      ex=(int)((float)10/xmag+30);
   if (mconf.spect.power!=NULL){
     if (mconf.spect.displayy)
        if (*(mconf.spect.power)<=0.001)
	   re=0;
        else
           re=(int)(log10(*(mconf.spect.power+1)/mconf.spect.maxpower*100+1)*ymag);
     else
        re=(int)((*(mconf.spect.power+1))*ymag);
   }
   else 
     re=0;
   p.setPen(QColor(mconf.col.ampl_data.r,mconf.col.ampl_data.g,mconf.col.ampl_data.b));
   for (i=1;i<mconf.spect.pn;i++)
   {
	if(mconf.spect.displayy)
           if (*(mconf.spect.power)<=0.001) 
	     ee=0;
	   else
	     ee=(int)(log10((*(mconf.spect.power+i))/(mconf.spect.maxpower)*100+1)*ymag);
	else
	   ee=(int)((*(mconf.spect.power+i))*ymag);
        if (mconf.spect.displayx==1)
	   x=(int)(log10((float)(mconf.wave.freq/2)/(float)(mconf.spect.pn)*(float)i)/xmag+30);
	else 
	   x=(int)((float)i/xmag+30);
	switch(mconf.spect.display)
	{
		case 0: p.drawLine(x,basey,x,basey-ee);break;
		case 1: for (k=ex;k<x;k++)
				{
					p.drawLine(k,basey,k,basey-ee);
				}
			break;
		case 2: p.drawLine(ex,basey-re,x,basey-ee);break;
	}
	re=ee;
	ex=x;
   }
   p.end();
}

FData::~FData()
{
}